diff --git a/src/backend/commands/copy.c b/src/backend/commands/copy.c
index c05e14e..55b955a 100644
--- a/src/backend/commands/copy.c
+++ b/src/backend/commands/copy.c
@@ -2669,6 +2669,8 @@ CopyFrom(CopyState cstate)
 					if (resultRelInfo->ri_NumIndices > 0)
 						recheckIndexes = ExecInsertIndexTuples(slot,
 															&(tuple->t_self),
+															&(tuple->t_self),
+															NULL,
 															   estate,
 															   false,
 															   NULL,
@@ -2823,6 +2825,7 @@ CopyFromInsertBatch(CopyState cstate, EState *estate, CommandId mycid,
 			ExecStoreTuple(bufferedTuples[i], myslot, InvalidBuffer, false);
 			recheckIndexes =
 				ExecInsertIndexTuples(myslot, &(bufferedTuples[i]->t_self),
+									  &(bufferedTuples[i]->t_self), NULL,
 									  estate, false, NULL, NIL);
 			ExecARInsertTriggers(estate, resultRelInfo,
 								 bufferedTuples[i],
diff --git a/src/backend/commands/dbcommands.c b/src/backend/commands/dbcommands.c
index 6ad8fd7..db9f9fc 100644
--- a/src/backend/commands/dbcommands.c
+++ b/src/backend/commands/dbcommands.c
@@ -549,7 +549,7 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 	simple_heap_insert(pg_database_rel, tuple);
 
 	/* Update indexes */
-	CatalogUpdateIndexes(pg_database_rel, tuple);
+	CatalogUpdateIndexes(pg_database_rel, tuple, false, NULL);
 
 	/*
 	 * Now generate additional catalog entries associated with the new DB
@@ -978,6 +978,8 @@ RenameDatabase(const char *oldname, const char *newname)
 	int			notherbackends;
 	int			npreparedxacts;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * Look up the target database's OID, and get exclusive lock on it. We
@@ -1040,8 +1042,9 @@ RenameDatabase(const char *oldname, const char *newname)
 	if (!HeapTupleIsValid(newtup))
 		elog(ERROR, "cache lookup failed for database %u", db_id);
 	namestrcpy(&(((Form_pg_database) GETSTRUCT(newtup))->datname), newname);
-	simple_heap_update(rel, &newtup->t_self, newtup);
-	CatalogUpdateIndexes(rel, newtup);
+	simple_heap_update(rel, &newtup->t_self, newtup, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(rel, newtup, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(DatabaseRelationId, db_id, 0);
 
@@ -1081,6 +1084,8 @@ movedb(const char *dbname, const char *tblspcname)
 	DIR		   *dstdir;
 	struct dirent *xlde;
 	movedb_failure_params fparms;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * Look up the target database's OID, and get exclusive lock on it. We
@@ -1296,10 +1301,11 @@ movedb(const char *dbname, const char *tblspcname)
 		newtuple = heap_modify_tuple(oldtuple, RelationGetDescr(pgdbrel),
 									 new_record,
 									 new_record_nulls, new_record_repl);
-		simple_heap_update(pgdbrel, &oldtuple->t_self, newtuple);
+		simple_heap_update(pgdbrel, &oldtuple->t_self, newtuple, &warm_update,
+				&modified_attrs);
 
 		/* Update indexes */
-		CatalogUpdateIndexes(pgdbrel, newtuple);
+		CatalogUpdateIndexes(pgdbrel, newtuple, warm_update, modified_attrs);
 
 		InvokeObjectPostAlterHook(DatabaseRelationId,
 								  HeapTupleGetOid(newtuple), 0);
@@ -1413,6 +1419,8 @@ AlterDatabase(ParseState *pstate, AlterDatabaseStmt *stmt, bool isTopLevel)
 	Datum		new_record[Natts_pg_database];
 	bool		new_record_nulls[Natts_pg_database];
 	bool		new_record_repl[Natts_pg_database];
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Extract options from the statement node tree */
 	foreach(option, stmt->options)
@@ -1554,10 +1562,11 @@ AlterDatabase(ParseState *pstate, AlterDatabaseStmt *stmt, bool isTopLevel)
 
 	newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel), new_record,
 								 new_record_nulls, new_record_repl);
-	simple_heap_update(rel, &tuple->t_self, newtuple);
+	simple_heap_update(rel, &tuple->t_self, newtuple, &warm_update,
+			&modified_attrs);
 
 	/* Update indexes */
-	CatalogUpdateIndexes(rel, newtuple);
+	CatalogUpdateIndexes(rel, newtuple, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(DatabaseRelationId,
 							  HeapTupleGetOid(newtuple), 0);
@@ -1610,6 +1619,8 @@ AlterDatabaseOwner(const char *dbname, Oid newOwnerId)
 	SysScanDesc scan;
 	Form_pg_database datForm;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * Get the old tuple.  We don't need a lock on the database per se,
@@ -1692,8 +1703,9 @@ AlterDatabaseOwner(const char *dbname, Oid newOwnerId)
 		}
 
 		newtuple = heap_modify_tuple(tuple, RelationGetDescr(rel), repl_val, repl_null, repl_repl);
-		simple_heap_update(rel, &newtuple->t_self, newtuple);
-		CatalogUpdateIndexes(rel, newtuple);
+		simple_heap_update(rel, &newtuple->t_self, newtuple, &warm_update,
+				&modified_attrs);
+		CatalogUpdateIndexes(rel, newtuple, warm_update, modified_attrs);
 
 		heap_freetuple(newtuple);
 
diff --git a/src/backend/commands/event_trigger.c b/src/backend/commands/event_trigger.c
index 8125537..63cdff8 100644
--- a/src/backend/commands/event_trigger.c
+++ b/src/backend/commands/event_trigger.c
@@ -406,7 +406,7 @@ insert_event_trigger_tuple(char *trigname, char *eventname, Oid evtOwner,
 	/* Insert heap tuple. */
 	tuple = heap_form_tuple(tgrel->rd_att, values, nulls);
 	trigoid = simple_heap_insert(tgrel, tuple);
-	CatalogUpdateIndexes(tgrel, tuple);
+	CatalogUpdateIndexes(tgrel, tuple, false, NULL);
 	heap_freetuple(tuple);
 
 	/* Depend on owner. */
@@ -503,6 +503,8 @@ AlterEventTrigger(AlterEventTrigStmt *stmt)
 	Oid			trigoid;
 	Form_pg_event_trigger evtForm;
 	char		tgenabled = stmt->tgenabled;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	tgrel = heap_open(EventTriggerRelationId, RowExclusiveLock);
 
@@ -524,8 +526,9 @@ AlterEventTrigger(AlterEventTrigStmt *stmt)
 	evtForm = (Form_pg_event_trigger) GETSTRUCT(tup);
 	evtForm->evtenabled = tgenabled;
 
-	simple_heap_update(tgrel, &tup->t_self, tup);
-	CatalogUpdateIndexes(tgrel, tup);
+	simple_heap_update(tgrel, &tup->t_self, tup, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(tgrel, tup, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(EventTriggerRelationId,
 							  trigoid, 0);
@@ -602,6 +605,8 @@ static void
 AlterEventTriggerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 {
 	Form_pg_event_trigger form;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	form = (Form_pg_event_trigger) GETSTRUCT(tup);
 
@@ -621,8 +626,8 @@ AlterEventTriggerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 			 errhint("The owner of an event trigger must be a superuser.")));
 
 	form->evtowner = newOwnerId;
-	simple_heap_update(rel, &tup->t_self, tup);
-	CatalogUpdateIndexes(rel, tup);
+	simple_heap_update(rel, &tup->t_self, tup, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 	/* Update owner dependency reference */
 	changeDependencyOnOwner(EventTriggerRelationId,
diff --git a/src/backend/commands/extension.c b/src/backend/commands/extension.c
index 554fdc4..01e6a54 100644
--- a/src/backend/commands/extension.c
+++ b/src/backend/commands/extension.c
@@ -1773,7 +1773,7 @@ InsertExtensionTuple(const char *extName, Oid extOwner,
 	tuple = heap_form_tuple(rel->rd_att, values, nulls);
 
 	extensionOid = simple_heap_insert(rel, tuple);
-	CatalogUpdateIndexes(rel, tuple);
+	CatalogUpdateIndexes(rel, tuple, false, NULL);
 
 	heap_freetuple(tuple);
 	heap_close(rel, RowExclusiveLock);
@@ -2332,6 +2332,8 @@ pg_extension_config_dump(PG_FUNCTION_ARGS)
 	bool		repl_null[Natts_pg_extension];
 	bool		repl_repl[Natts_pg_extension];
 	ArrayType  *a;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * We only allow this to be called from an extension's SQL script. We
@@ -2484,8 +2486,9 @@ pg_extension_config_dump(PG_FUNCTION_ARGS)
 	extTup = heap_modify_tuple(extTup, RelationGetDescr(extRel),
 							   repl_val, repl_null, repl_repl);
 
-	simple_heap_update(extRel, &extTup->t_self, extTup);
-	CatalogUpdateIndexes(extRel, extTup);
+	simple_heap_update(extRel, &extTup->t_self, extTup, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(extRel, extTup, warm_update, modified_attrs);
 
 	systable_endscan(extScan);
 
@@ -2516,6 +2519,8 @@ extension_config_remove(Oid extensionoid, Oid tableoid)
 	bool		repl_null[Natts_pg_extension];
 	bool		repl_repl[Natts_pg_extension];
 	ArrayType  *a;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Find the pg_extension tuple */
 	extRel = heap_open(ExtensionRelationId, RowExclusiveLock);
@@ -2662,8 +2667,9 @@ extension_config_remove(Oid extensionoid, Oid tableoid)
 	extTup = heap_modify_tuple(extTup, RelationGetDescr(extRel),
 							   repl_val, repl_null, repl_repl);
 
-	simple_heap_update(extRel, &extTup->t_self, extTup);
-	CatalogUpdateIndexes(extRel, extTup);
+	simple_heap_update(extRel, &extTup->t_self, extTup, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(extRel, extTup, warm_update, modified_attrs);
 
 	systable_endscan(extScan);
 
@@ -2691,6 +2697,8 @@ AlterExtensionNamespace(List *names, const char *newschema, Oid *oldschema)
 	HeapTuple	depTup;
 	ObjectAddresses *objsMoved;
 	ObjectAddress extAddr;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	if (list_length(names) != 1)
 		ereport(ERROR,
@@ -2843,8 +2851,9 @@ AlterExtensionNamespace(List *names, const char *newschema, Oid *oldschema)
 	/* Now adjust pg_extension.extnamespace */
 	extForm->extnamespace = nspOid;
 
-	simple_heap_update(extRel, &extTup->t_self, extTup);
-	CatalogUpdateIndexes(extRel, extTup);
+	simple_heap_update(extRel, &extTup->t_self, extTup, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(extRel, extTup, warm_update, modified_attrs);
 
 	heap_close(extRel, RowExclusiveLock);
 
@@ -3042,6 +3051,8 @@ ApplyExtensionUpdates(Oid extensionOid,
 		bool		repl[Natts_pg_extension];
 		ObjectAddress myself;
 		ListCell   *lc;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		/*
 		 * Fetch parameters for specific version (pcontrol is not changed)
@@ -3090,8 +3101,9 @@ ApplyExtensionUpdates(Oid extensionOid,
 		extTup = heap_modify_tuple(extTup, RelationGetDescr(extRel),
 								   values, nulls, repl);
 
-		simple_heap_update(extRel, &extTup->t_self, extTup);
-		CatalogUpdateIndexes(extRel, extTup);
+		simple_heap_update(extRel, &extTup->t_self, extTup, &warm_update,
+				&modified_attrs);
+		CatalogUpdateIndexes(extRel, extTup, warm_update, modified_attrs);
 
 		systable_endscan(extScan);
 
diff --git a/src/backend/commands/foreigncmds.c b/src/backend/commands/foreigncmds.c
index 476a023..d76ccda 100644
--- a/src/backend/commands/foreigncmds.c
+++ b/src/backend/commands/foreigncmds.c
@@ -234,6 +234,9 @@ AlterForeignDataWrapperOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerI
 
 	if (form->fdwowner != newOwnerId)
 	{
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
+
 		memset(repl_null, false, sizeof(repl_null));
 		memset(repl_repl, false, sizeof(repl_repl));
 
@@ -256,8 +259,9 @@ AlterForeignDataWrapperOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerI
 		tup = heap_modify_tuple(tup, RelationGetDescr(rel), repl_val, repl_null,
 								repl_repl);
 
-		simple_heap_update(rel, &tup->t_self, tup);
-		CatalogUpdateIndexes(rel, tup);
+		simple_heap_update(rel, &tup->t_self, tup, &warm_update,
+				&modified_attrs);
+		CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 		/* Update owner dependency reference */
 		changeDependencyOnOwner(ForeignDataWrapperRelationId,
@@ -349,6 +353,9 @@ AlterForeignServerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 
 	if (form->srvowner != newOwnerId)
 	{
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
+
 		/* Superusers can always do it */
 		if (!superuser())
 		{
@@ -397,8 +404,9 @@ AlterForeignServerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 		tup = heap_modify_tuple(tup, RelationGetDescr(rel), repl_val, repl_null,
 								repl_repl);
 
-		simple_heap_update(rel, &tup->t_self, tup);
-		CatalogUpdateIndexes(rel, tup);
+		simple_heap_update(rel, &tup->t_self, tup, &warm_update,
+				&modified_attrs);
+		CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 		/* Update owner dependency reference */
 		changeDependencyOnOwner(ForeignServerRelationId, HeapTupleGetOid(tup),
@@ -630,7 +638,7 @@ CreateForeignDataWrapper(CreateFdwStmt *stmt)
 	tuple = heap_form_tuple(rel->rd_att, values, nulls);
 
 	fdwId = simple_heap_insert(rel, tuple);
-	CatalogUpdateIndexes(rel, tuple);
+	CatalogUpdateIndexes(rel, tuple, false, NULL);
 
 	heap_freetuple(tuple);
 
@@ -689,6 +697,8 @@ AlterForeignDataWrapper(AlterFdwStmt *stmt)
 	Oid			fdwhandler;
 	Oid			fdwvalidator;
 	ObjectAddress myself;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	rel = heap_open(ForeignDataWrapperRelationId, RowExclusiveLock);
 
@@ -786,8 +796,8 @@ AlterForeignDataWrapper(AlterFdwStmt *stmt)
 	tp = heap_modify_tuple(tp, RelationGetDescr(rel),
 						   repl_val, repl_null, repl_repl);
 
-	simple_heap_update(rel, &tp->t_self, tp);
-	CatalogUpdateIndexes(rel, tp);
+	simple_heap_update(rel, &tp->t_self, tp, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tp, warm_update, modified_attrs);
 
 	heap_freetuple(tp);
 
@@ -943,7 +953,7 @@ CreateForeignServer(CreateForeignServerStmt *stmt)
 
 	srvId = simple_heap_insert(rel, tuple);
 
-	CatalogUpdateIndexes(rel, tuple);
+	CatalogUpdateIndexes(rel, tuple, false, NULL);
 
 	heap_freetuple(tuple);
 
@@ -985,6 +995,8 @@ AlterForeignServer(AlterForeignServerStmt *stmt)
 	Oid			srvId;
 	Form_pg_foreign_server srvForm;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	rel = heap_open(ForeignServerRelationId, RowExclusiveLock);
 
@@ -1056,8 +1068,8 @@ AlterForeignServer(AlterForeignServerStmt *stmt)
 	tp = heap_modify_tuple(tp, RelationGetDescr(rel),
 						   repl_val, repl_null, repl_repl);
 
-	simple_heap_update(rel, &tp->t_self, tp);
-	CatalogUpdateIndexes(rel, tp);
+	simple_heap_update(rel, &tp->t_self, tp, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tp, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(ForeignServerRelationId, srvId, 0);
 
@@ -1192,7 +1204,7 @@ CreateUserMapping(CreateUserMappingStmt *stmt)
 
 	umId = simple_heap_insert(rel, tuple);
 
-	CatalogUpdateIndexes(rel, tuple);
+	CatalogUpdateIndexes(rel, tuple, false, NULL);
 
 	heap_freetuple(tuple);
 
@@ -1240,6 +1252,8 @@ AlterUserMapping(AlterUserMappingStmt *stmt)
 	ForeignServer *srv;
 	ObjectAddress address;
 	RoleSpec   *role = (RoleSpec *) stmt->user;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	rel = heap_open(UserMappingRelationId, RowExclusiveLock);
 
@@ -1307,8 +1321,8 @@ AlterUserMapping(AlterUserMappingStmt *stmt)
 	tp = heap_modify_tuple(tp, RelationGetDescr(rel),
 						   repl_val, repl_null, repl_repl);
 
-	simple_heap_update(rel, &tp->t_self, tp);
-	CatalogUpdateIndexes(rel, tp);
+	simple_heap_update(rel, &tp->t_self, tp, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tp, warm_update, modified_attrs);
 
 	ObjectAddressSet(address, UserMappingRelationId, umId);
 
@@ -1485,7 +1499,7 @@ CreateForeignTable(CreateForeignTableStmt *stmt, Oid relid)
 	tuple = heap_form_tuple(ftrel->rd_att, values, nulls);
 
 	simple_heap_insert(ftrel, tuple);
-	CatalogUpdateIndexes(ftrel, tuple);
+	CatalogUpdateIndexes(ftrel, tuple, false, NULL);
 
 	heap_freetuple(tuple);
 
diff --git a/src/backend/commands/functioncmds.c b/src/backend/commands/functioncmds.c
index 22aecb2..8a48bdc 100644
--- a/src/backend/commands/functioncmds.c
+++ b/src/backend/commands/functioncmds.c
@@ -1181,6 +1181,8 @@ AlterFunction(ParseState *pstate, AlterFunctionStmt *stmt)
 	DefElem    *rows_item = NULL;
 	DefElem    *parallel_item = NULL;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	rel = heap_open(ProcedureRelationId, RowExclusiveLock);
 
@@ -1295,8 +1297,8 @@ AlterFunction(ParseState *pstate, AlterFunctionStmt *stmt)
 		procForm->proparallel = interpret_func_parallel(parallel_item);
 
 	/* Do the update */
-	simple_heap_update(rel, &tup->t_self, tup);
-	CatalogUpdateIndexes(rel, tup);
+	simple_heap_update(rel, &tup->t_self, tup, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(ProcedureRelationId, funcOid, 0);
 
@@ -1321,6 +1323,8 @@ SetFunctionReturnType(Oid funcOid, Oid newRetType)
 	Relation	pg_proc_rel;
 	HeapTuple	tup;
 	Form_pg_proc procForm;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	pg_proc_rel = heap_open(ProcedureRelationId, RowExclusiveLock);
 
@@ -1336,9 +1340,10 @@ SetFunctionReturnType(Oid funcOid, Oid newRetType)
 	procForm->prorettype = newRetType;
 
 	/* update the catalog and its indexes */
-	simple_heap_update(pg_proc_rel, &tup->t_self, tup);
+	simple_heap_update(pg_proc_rel, &tup->t_self, tup, &warm_update,
+			&modified_attrs);
 
-	CatalogUpdateIndexes(pg_proc_rel, tup);
+	CatalogUpdateIndexes(pg_proc_rel, tup, warm_update, modified_attrs);
 
 	heap_close(pg_proc_rel, RowExclusiveLock);
 }
@@ -1355,6 +1360,8 @@ SetFunctionArgType(Oid funcOid, int argIndex, Oid newArgType)
 	Relation	pg_proc_rel;
 	HeapTuple	tup;
 	Form_pg_proc procForm;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	pg_proc_rel = heap_open(ProcedureRelationId, RowExclusiveLock);
 
@@ -1371,9 +1378,10 @@ SetFunctionArgType(Oid funcOid, int argIndex, Oid newArgType)
 	procForm->proargtypes.values[argIndex] = newArgType;
 
 	/* update the catalog and its indexes */
-	simple_heap_update(pg_proc_rel, &tup->t_self, tup);
+	simple_heap_update(pg_proc_rel, &tup->t_self, tup, &warm_update,
+			&modified_attrs);
 
-	CatalogUpdateIndexes(pg_proc_rel, tup);
+	CatalogUpdateIndexes(pg_proc_rel, tup, warm_update, modified_attrs);
 
 	heap_close(pg_proc_rel, RowExclusiveLock);
 }
@@ -1661,7 +1669,7 @@ CreateCast(CreateCastStmt *stmt)
 
 	castid = simple_heap_insert(relation, tuple);
 
-	CatalogUpdateIndexes(relation, tuple);
+	CatalogUpdateIndexes(relation, tuple, false, NULL);
 
 	/* make dependency entries */
 	myself.classId = CastRelationId;
@@ -1806,6 +1814,8 @@ CreateTransform(CreateTransformStmt *stmt)
 	ObjectAddress myself,
 				referenced;
 	bool		is_replace;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/*
 	 * Get the type
@@ -1924,7 +1934,8 @@ CreateTransform(CreateTransformStmt *stmt)
 		replaces[Anum_pg_transform_trftosql - 1] = true;
 
 		newtuple = heap_modify_tuple(tuple, RelationGetDescr(relation), values, nulls, replaces);
-		simple_heap_update(relation, &newtuple->t_self, newtuple);
+		simple_heap_update(relation, &newtuple->t_self, newtuple, &warm_update,
+				&modified_attrs);
 
 		transformid = HeapTupleGetOid(tuple);
 		ReleaseSysCache(tuple);
@@ -1935,9 +1946,11 @@ CreateTransform(CreateTransformStmt *stmt)
 		newtuple = heap_form_tuple(RelationGetDescr(relation), values, nulls);
 		transformid = simple_heap_insert(relation, newtuple);
 		is_replace = false;
+		warm_update = false;
+		modified_attrs = NULL;
 	}
 
-	CatalogUpdateIndexes(relation, newtuple);
+	CatalogUpdateIndexes(relation, newtuple, warm_update, modified_attrs);
 
 	if (is_replace)
 		deleteDependencyRecordsFor(TransformRelationId, transformid, true);
diff --git a/src/backend/commands/matview.c b/src/backend/commands/matview.c
index 6b5a9b6..c22173d 100644
--- a/src/backend/commands/matview.c
+++ b/src/backend/commands/matview.c
@@ -83,6 +83,8 @@ SetMatViewPopulatedState(Relation relation, bool newstate)
 {
 	Relation	pgrel;
 	HeapTuple	tuple;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	Assert(relation->rd_rel->relkind == RELKIND_MATVIEW);
 
@@ -100,9 +102,10 @@ SetMatViewPopulatedState(Relation relation, bool newstate)
 
 	((Form_pg_class) GETSTRUCT(tuple))->relispopulated = newstate;
 
-	simple_heap_update(pgrel, &tuple->t_self, tuple);
+	simple_heap_update(pgrel, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
 
-	CatalogUpdateIndexes(pgrel, tuple);
+	CatalogUpdateIndexes(pgrel, tuple, warm_update, modified_attrs);
 
 	heap_freetuple(tuple);
 	heap_close(pgrel, RowExclusiveLock);
diff --git a/src/backend/commands/opclasscmds.c b/src/backend/commands/opclasscmds.c
index 7cfcc6d..609d92b 100644
--- a/src/backend/commands/opclasscmds.c
+++ b/src/backend/commands/opclasscmds.c
@@ -280,7 +280,7 @@ CreateOpFamily(char *amname, char *opfname, Oid namespaceoid, Oid amoid)
 
 	opfamilyoid = simple_heap_insert(rel, tup);
 
-	CatalogUpdateIndexes(rel, tup);
+	CatalogUpdateIndexes(rel, tup, false, NULL);
 
 	heap_freetuple(tup);
 
@@ -657,7 +657,7 @@ DefineOpClass(CreateOpClassStmt *stmt)
 
 	opclassoid = simple_heap_insert(rel, tup);
 
-	CatalogUpdateIndexes(rel, tup);
+	CatalogUpdateIndexes(rel, tup, false, NULL);
 
 	heap_freetuple(tup);
 
@@ -1332,7 +1332,7 @@ storeOperators(List *opfamilyname, Oid amoid,
 
 		entryoid = simple_heap_insert(rel, tup);
 
-		CatalogUpdateIndexes(rel, tup);
+		CatalogUpdateIndexes(rel, tup, false, NULL);
 
 		heap_freetuple(tup);
 
@@ -1443,7 +1443,7 @@ storeProcedures(List *opfamilyname, Oid amoid,
 
 		entryoid = simple_heap_insert(rel, tup);
 
-		CatalogUpdateIndexes(rel, tup);
+		CatalogUpdateIndexes(rel, tup, false, NULL);
 
 		heap_freetuple(tup);
 
diff --git a/src/backend/commands/operatorcmds.c b/src/backend/commands/operatorcmds.c
index a273376..e93a71a 100644
--- a/src/backend/commands/operatorcmds.c
+++ b/src/backend/commands/operatorcmds.c
@@ -400,6 +400,8 @@ AlterOperator(AlterOperatorStmt *stmt)
 	List	   *joinName = NIL; /* optional join sel. procedure */
 	bool		updateJoin = false;
 	Oid			joinOid;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Look up the operator */
 	oprId = LookupOperNameTypeNames(NULL, stmt->opername,
@@ -518,8 +520,9 @@ AlterOperator(AlterOperatorStmt *stmt)
 	tup = heap_modify_tuple(tup, RelationGetDescr(catalog),
 							values, nulls, replaces);
 
-	simple_heap_update(catalog, &tup->t_self, tup);
-	CatalogUpdateIndexes(catalog, tup);
+	simple_heap_update(catalog, &tup->t_self, tup, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(catalog, tup, warm_update, modified_attrs);
 
 	address = makeOperatorDependencies(tup, true);
 
diff --git a/src/backend/commands/policy.c b/src/backend/commands/policy.c
index 5d9d3a6..a080fc0 100644
--- a/src/backend/commands/policy.c
+++ b/src/backend/commands/policy.c
@@ -536,6 +536,8 @@ RemoveRoleFromObjectPolicy(Oid roleid, Oid classid, Oid policy_id)
 		HeapTuple	new_tuple;
 		ObjectAddress target;
 		ObjectAddress myself;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		/* zero-clear */
 		memset(values, 0, sizeof(values));
@@ -614,10 +616,12 @@ RemoveRoleFromObjectPolicy(Oid roleid, Oid classid, Oid policy_id)
 		new_tuple = heap_modify_tuple(tuple,
 									  RelationGetDescr(pg_policy_rel),
 									  values, isnull, replaces);
-		simple_heap_update(pg_policy_rel, &new_tuple->t_self, new_tuple);
+		simple_heap_update(pg_policy_rel, &new_tuple->t_self, new_tuple,
+				&warm_update, &modified_attrs);
 
 		/* Update Catalog Indexes */
-		CatalogUpdateIndexes(pg_policy_rel, new_tuple);
+		CatalogUpdateIndexes(pg_policy_rel, new_tuple, warm_update,
+				modified_attrs);
 
 		/* Remove all old dependencies. */
 		deleteDependencyRecordsFor(PolicyRelationId, policy_id, false);
@@ -826,7 +830,7 @@ CreatePolicy(CreatePolicyStmt *stmt)
 	policy_id = simple_heap_insert(pg_policy_rel, policy_tuple);
 
 	/* Update Indexes */
-	CatalogUpdateIndexes(pg_policy_rel, policy_tuple);
+	CatalogUpdateIndexes(pg_policy_rel, policy_tuple, false, NULL);
 
 	/* Record Dependencies */
 	target.classId = RelationRelationId;
@@ -906,6 +910,8 @@ AlterPolicy(AlterPolicyStmt *stmt)
 	char		polcmd;
 	bool		polcmd_isnull;
 	int			i;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Parse role_ids */
 	if (stmt->roles != NULL)
@@ -1150,10 +1156,12 @@ AlterPolicy(AlterPolicyStmt *stmt)
 	new_tuple = heap_modify_tuple(policy_tuple,
 								  RelationGetDescr(pg_policy_rel),
 								  values, isnull, replaces);
-	simple_heap_update(pg_policy_rel, &new_tuple->t_self, new_tuple);
+	simple_heap_update(pg_policy_rel, &new_tuple->t_self, new_tuple,
+			&warm_update, &modified_attrs);
 
 	/* Update Catalog Indexes */
-	CatalogUpdateIndexes(pg_policy_rel, new_tuple);
+	CatalogUpdateIndexes(pg_policy_rel, new_tuple, warm_update,
+			modified_attrs);
 
 	/* Update Dependencies. */
 	deleteDependencyRecordsFor(PolicyRelationId, policy_id, false);
@@ -1217,6 +1225,8 @@ rename_policy(RenameStmt *stmt)
 	SysScanDesc sscan;
 	HeapTuple	policy_tuple;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Get id of table.  Also handles permissions checks. */
 	table_id = RangeVarGetRelidExtended(stmt->relation, AccessExclusiveLock,
@@ -1287,10 +1297,12 @@ rename_policy(RenameStmt *stmt)
 	namestrcpy(&((Form_pg_policy) GETSTRUCT(policy_tuple))->polname,
 			   stmt->newname);
 
-	simple_heap_update(pg_policy_rel, &policy_tuple->t_self, policy_tuple);
+	simple_heap_update(pg_policy_rel, &policy_tuple->t_self, policy_tuple,
+			&warm_update, &modified_attrs);
 
 	/* keep system catalog indexes current */
-	CatalogUpdateIndexes(pg_policy_rel, policy_tuple);
+	CatalogUpdateIndexes(pg_policy_rel, policy_tuple, warm_update,
+			modified_attrs);
 
 	InvokeObjectPostAlterHook(PolicyRelationId,
 							  HeapTupleGetOid(policy_tuple), 0);
diff --git a/src/backend/commands/proclang.c b/src/backend/commands/proclang.c
index b684f41..aae5ef6 100644
--- a/src/backend/commands/proclang.c
+++ b/src/backend/commands/proclang.c
@@ -336,6 +336,8 @@ create_proc_lang(const char *languageName, bool replace,
 	bool		is_update;
 	ObjectAddress myself,
 				referenced;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	rel = heap_open(LanguageRelationId, RowExclusiveLock);
 	tupDesc = RelationGetDescr(rel);
@@ -378,7 +380,8 @@ create_proc_lang(const char *languageName, bool replace,
 
 		/* Okay, do it... */
 		tup = heap_modify_tuple(oldtup, tupDesc, values, nulls, replaces);
-		simple_heap_update(rel, &tup->t_self, tup);
+		simple_heap_update(rel, &tup->t_self, tup, &warm_update,
+				&modified_attrs);
 
 		ReleaseSysCache(oldtup);
 		is_update = true;
@@ -389,10 +392,12 @@ create_proc_lang(const char *languageName, bool replace,
 		tup = heap_form_tuple(tupDesc, values, nulls);
 		simple_heap_insert(rel, tup);
 		is_update = false;
+		warm_update = false;
+		modified_attrs = NULL;
 	}
 
 	/* Need to update indexes for either the insert or update case */
-	CatalogUpdateIndexes(rel, tup);
+	CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 	/*
 	 * Create dependencies for the new language.  If we are updating an
diff --git a/src/backend/commands/publicationcmds.c b/src/backend/commands/publicationcmds.c
index 63dcc10..4980b36 100644
--- a/src/backend/commands/publicationcmds.c
+++ b/src/backend/commands/publicationcmds.c
@@ -215,7 +215,7 @@ CreatePublication(CreatePublicationStmt *stmt)
 
 	/* Insert tuple into catalog. */
 	puboid = simple_heap_insert(rel, tup);
-	CatalogUpdateIndexes(rel, tup);
+	CatalogUpdateIndexes(rel, tup, false, NULL);
 	heap_freetuple(tup);
 
 	recordDependencyOnOwner(PublicationRelationId, puboid, GetUserId());
@@ -260,6 +260,8 @@ AlterPublicationOptions(AlterPublicationStmt *stmt, Relation rel,
 	bool		publish_update;
 	bool		publish_delete;
 	ObjectAddress		obj;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	parse_publication_options(stmt->options,
 							  &publish_insert_given, &publish_insert,
@@ -294,8 +296,8 @@ AlterPublicationOptions(AlterPublicationStmt *stmt, Relation rel,
 							replaces);
 
 	/* Update the catalog. */
-	simple_heap_update(rel, &tup->t_self, tup);
-	CatalogUpdateIndexes(rel, tup);
+	simple_heap_update(rel, &tup->t_self, tup, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 	CommandCounterIncrement();
 
@@ -666,6 +668,8 @@ PublicationDropTables(Oid pubid, List *rels, bool missing_ok)
 AlterPublicationOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 {
 	Form_pg_publication form;
+	bool				warm_update;
+	Bitmapset			*modified_attrs;
 
 	form = (Form_pg_publication) GETSTRUCT(tup);
 
@@ -685,8 +689,8 @@ AlterPublicationOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 				 errhint("The owner of a publication must be a superuser.")));
 
 	form->pubowner = newOwnerId;
-	simple_heap_update(rel, &tup->t_self, tup);
-	CatalogUpdateIndexes(rel, tup);
+	simple_heap_update(rel, &tup->t_self, tup, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 	/* Update owner dependency reference */
 	changeDependencyOnOwner(PublicationRelationId,
diff --git a/src/backend/commands/schemacmds.c b/src/backend/commands/schemacmds.c
index c3b37b2..d89e093 100644
--- a/src/backend/commands/schemacmds.c
+++ b/src/backend/commands/schemacmds.c
@@ -245,6 +245,8 @@ RenameSchema(const char *oldname, const char *newname)
 	Relation	rel;
 	AclResult	aclresult;
 	ObjectAddress address;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	rel = heap_open(NamespaceRelationId, RowExclusiveLock);
 
@@ -281,8 +283,8 @@ RenameSchema(const char *oldname, const char *newname)
 
 	/* rename */
 	namestrcpy(&(((Form_pg_namespace) GETSTRUCT(tup))->nspname), newname);
-	simple_heap_update(rel, &tup->t_self, tup);
-	CatalogUpdateIndexes(rel, tup);
+	simple_heap_update(rel, &tup->t_self, tup, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 	InvokeObjectPostAlterHook(NamespaceRelationId, HeapTupleGetOid(tup), 0);
 
@@ -370,6 +372,8 @@ AlterSchemaOwner_internal(HeapTuple tup, Relation rel, Oid newOwnerId)
 		bool		isNull;
 		HeapTuple	newtuple;
 		AclResult	aclresult;
+		bool		warm_update;
+		Bitmapset	*modified_attrs;
 
 		/* Otherwise, must be owner of the existing object */
 		if (!pg_namespace_ownercheck(HeapTupleGetOid(tup), GetUserId()))
@@ -417,8 +421,9 @@ AlterSchemaOwner_internal(HeapTuple tup, Relation rel, Oid newOwnerId)
 
 		newtuple = heap_modify_tuple(tup, RelationGetDescr(rel), repl_val, repl_null, repl_repl);
 
-		simple_heap_update(rel, &newtuple->t_self, newtuple);
-		CatalogUpdateIndexes(rel, newtuple);
+		simple_heap_update(rel, &newtuple->t_self, newtuple, &warm_update,
+				&modified_attrs); CatalogUpdateIndexes(rel, newtuple,
+					warm_update, modified_attrs);
 
 		heap_freetuple(newtuple);
 
